package umicollapse.main;

import java.io.File;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import umicollapse.algo.Adjacency;
import umicollapse.algo.Algo;
import umicollapse.algo.ConnectedComponents;
import umicollapse.algo.Directional;
import umicollapse.algo.ParallelAdjacency;
import umicollapse.algo.ParallelConnectedComponents;
import umicollapse.algo.ParallelDirectional;
import umicollapse.data.BKTree;
import umicollapse.data.Combo;
import umicollapse.data.FenwickBKTree;
import umicollapse.data.Naive;
import umicollapse.data.Ngram;
import umicollapse.data.NgramBKTree;
import umicollapse.data.ParallelBKTree;
import umicollapse.data.ParallelFenwickBKTree;
import umicollapse.data.ParallelNaive;
import umicollapse.data.SortBKTree;
import umicollapse.data.SortNgramBKTree;
import umicollapse.data.SymmetricDelete;
import umicollapse.data.Trie;
import umicollapse.main.DeduplicateFASTQ;
import umicollapse.main.DeduplicateSAM;
import umicollapse.merge.AnyMerge;
import umicollapse.merge.AvgQualMerge;
import umicollapse.merge.MapQualMerge;
import umicollapse.merge.Merge;

public class Main {

   public static void main(String[] var0) {
      System.out.println(Arrays.toString(var0));
      long var1 = System.currentTimeMillis();
      if(var0.length == 0) {
         throw new IllegalArgumentException("No arguments specified!");
      } else {
         HashMap var3 = new HashMap();
         String var4 = null;

         for(int var5 = 1; var5 < var0.length; ++var5) {
            if(var0[var5].startsWith("-")) {
               var4 = var0[var5];
               var3.put(var0[var5], new ArrayList());
            } else {
               ((List)var3.get(var4)).add(var0[var5]);
            }
         }

         HashMap var36 = new HashMap();
         HashMap var6 = new HashMap();
         var6.put("adj", Adjacency.class);
         var6.put("dir", Directional.class);
         var6.put("cc", ConnectedComponents.class);
         var36.put(Boolean.valueOf(false), var6);
         HashMap var7 = new HashMap();
         var7.put("adj", ParallelAdjacency.class);
         var7.put("dir", ParallelDirectional.class);
         var7.put("cc", ParallelConnectedComponents.class);
         var36.put(Boolean.valueOf(true), var7);
         HashMap var8 = new HashMap();
         HashMap var9 = new HashMap();
         var9.put("naive", Naive.class);
         var9.put("combo", Combo.class);
         var9.put("ngram", Ngram.class);
         var9.put("delete", SymmetricDelete.class);
         var9.put("trie", Trie.class);
         var9.put("bktree", BKTree.class);
         var9.put("sortbktree", SortBKTree.class);
         var9.put("ngrambktree", NgramBKTree.class);
         var9.put("sortngrambktree", SortNgramBKTree.class);
         var9.put("fenwickbktree", FenwickBKTree.class);
         var8.put(Boolean.valueOf(false), var9);
         HashMap var10 = new HashMap();
         var10.put("naive", ParallelNaive.class);
         var10.put("bktree", ParallelBKTree.class);
         var10.put("fenwickbktree", ParallelFenwickBKTree.class);
         var8.put(Boolean.valueOf(true), var10);
         HashMap var11 = new HashMap();
         var11.put("any", AnyMerge.class);
         var11.put("avgqual", AvgQualMerge.class);
         var11.put("mapqual", MapQualMerge.class);
         String var12 = var0[0];
         File var13 = null;
         File var14 = null;
         String var15 = "dir";
         String var16 = "ngrambktree";
         String var17 = var12.equals("fastq")?"avgqual":"mapqual";
         int var18 = 1;
         int var19 = -1;
         float var20 = 0.5F;
         String var21 = "_";
         boolean var22 = false;
         boolean var23 = false;
         boolean var24 = false;
         boolean var25 = false;
         boolean var26 = false;
         boolean var27 = false;
         boolean var28 = false;
         boolean var29 = false;
         String var30 = "-k";
         if(var3.containsKey(var30)) {
            var18 = Integer.parseInt((String)((List)var3.get(var30)).get(0));
         }

         var30 = "-u";
         if(var3.containsKey(var30)) {
            var19 = Integer.parseInt((String)((List)var3.get(var30)).get(0));
         }

         var30 = "-p";
         if(var3.containsKey(var30)) {
            var20 = Float.parseFloat((String)((List)var3.get(var30)).get(0));
         }

         var30 = "-i";
         if(var3.containsKey(var30)) {
            var13 = new File((String)((List)var3.get(var30)).get(0));
            var30 = "-o";
            if(!var3.containsKey(var30)) {
               throw new IllegalArgumentException("Missing output file!");
            } else {
               var14 = new File((String)((List)var3.get(var30)).get(0));
               var30 = "-t";
               if(var3.containsKey(var30)) {
                  System.setProperty("java.util.concurrent.ForkJoinPool.common.parallelism", Integer.parseInt((String)((List)var3.get(var30)).get(0)) - 1);
                  var23 = true;
                  var22 = false;
               }

               var30 = "-T";
               if(var3.containsKey(var30)) {
                  System.setProperty("java.util.concurrent.ForkJoinPool.common.parallelism", Integer.parseInt((String)((List)var3.get(var30)).get(0)) - 1);
                  var22 = true;
                  var23 = false;
               }

               var30 = "--algo";
               if(var3.containsKey(var30)) {
                  var15 = (String)((List)var3.get(var30)).get(0);
               }

               var30 = "--data";
               if(var3.containsKey(var30)) {
                  var16 = (String)((List)var3.get(var30)).get(0);
               }

               var30 = "--merge";
               if(var3.containsKey(var30)) {
                  var17 = (String)((List)var3.get(var30)).get(0);
               }

               var30 = "--umi-sep";
               if(var3.containsKey(var30)) {
                  var21 = (String)((List)var3.get(var30)).get(0);
               }

               var30 = "--two-pass";
               if(var3.containsKey(var30)) {
                  var24 = true;
               }

               var30 = "--paired";
               if(var3.containsKey(var30)) {
                  var25 = true;
               }

               var30 = "--remove-unpaired";
               if(var3.containsKey(var30)) {
                  var26 = true;
               }

               var30 = "--remove-chimeric";
               if(var3.containsKey(var30)) {
                  var27 = true;
               }

               var30 = "--keep-unmapped";
               if(var3.containsKey(var30)) {
                  var28 = true;
               }

               var30 = "--tag";
               if(var3.containsKey(var30)) {
                  var29 = true;
               }

               if(var29 && var24) {
                  throw new UnsupportedOperationException("Cannot track clusters with the two pass algorithm!");
               } else if(var25 && var23) {
                  throw new UnsupportedOperationException("Cannot process paired-end reads in parallel!");
               } else if(var25 && var28) {
                  throw new UnsupportedOperationException("Cannot keep unmapped reads with paired-end reads!");
               } else {
                  Algo var31 = null;
                  Class var32 = null;
                  Merge var33 = null;
                  var32 = (Class)((Map)var8.get(Boolean.valueOf(var22))).get(var16);

                  try {
                     var31 = (Algo)((Class)((Map)var36.get(Boolean.valueOf(var22))).get(var15)).getDeclaredConstructor(new Class[0]).newInstance(new Object[0]);
                     var33 = (Merge)((Class)var11.get(var17)).getDeclaredConstructor(new Class[0]).newInstance(new Object[0]);
                  } catch (Exception var35) {
                     var35.printStackTrace();
                  }

                  if(var12.equals("fastq")) {
                     DeduplicateFASTQ var34 = new DeduplicateFASTQ();
                     var34.deduplicateAndMerge(var13, var14, var31, var32, var33, var19, var18, var20, var23, var29);
                  } else if(var12.equals("bam") || var12.equals("sam")) {
                     DeduplicateSAM var37 = new DeduplicateSAM();
                     if(var24) {
                        var37.deduplicateAndMergeTwoPass(var13, var14, var31, var32, var33, var19, var18, var20, var21, var25, var26, var27, var28, var29);
                     } else {
                        var37.deduplicateAndMerge(var13, var14, var31, var32, var33, var19, var18, var20, var23, var21, var25, var26, var27, var28, var29);
                     }
                  }

                  System.out.println((double)(System.currentTimeMillis() - var1) / 1000.0D);
               }
            }
         } else {
            throw new IllegalArgumentException("Missing input file!");
         }
      }
   }
}
